#!/usr/bin/perl
# local_math.pl
use v5.14;

Local::Math->divide(1, 2);
Local::Math->divide(3, 4);
Local::Math->divide(4);
Local::Math->divide(5, 7);

package Local::Math {
    use Carp qw(croak);

    sub divide {
        my( $class, $numerator, $denominator ) = @_;
        croak q(Can't divide by zero!) if $denominator == 0;
        $numerator / $denominator;
        }
    }