#!/usr/bin/perl
# message_pack.pl

use v5.10;

use Data::MessagePack;
use Data::Dumper;

my %hash = qw(
    Fred    Flintstone
    Barney  Rubble
    Key     12345
    );

my $mp = Data::MessagePack->new;
$mp->canonical->utf8->prefer_integer;

my $packed   = $mp->pack( \%hash );
say 'Length of packed is ', length $packed;

say Dumper( $mp->unpack( $packed ) );